* PACKAGE DZ2PSI    !" ٤ήؿ( psi=const.)
*
*"  [HIS] 95/08/09 (takepiro) for psi=0 
*"        95/08/29 (takepiro) for psi=const
***********************************************************************
      SUBROUTINE DZ2PSI     !" ٤ήؿ( psi=const)
     O           ( PSI   , 
     I             ZETA  ,
     I             PSIBTM, PSITOP, 
     I             DX    , DZ      )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL       PSI  ( 0:NX+1 , 0:NZ+1 )  !" ήؿ
*
* [INPUT]
      REAL       ZETA ( 0:NX+1 , 0:NZ+1 )  !" 
      REAL       PSIBTM         !" üήؿ
      REAL       PSITOP         !" üήؿ
      REAL       DX             !" Xγʻֳ
      REAL       DZ             !" Zγʻֳ
*
* [INTERNAL SAVE]
      REAL      ALU  ( NX , NZ, -1:1  ) !" (3г)
      REAL      WTBL ( 2  , NX ) !" Ѵؿɽ
      LOGICAL   OFIRST
*
* [INTERNAL WORK]
      REAL      Z    ( NX , NZ ) !" 
      INTEGER 	IX, IZ
      INTEGER 	IFAC
*
      DATA    OFIRST / .TRUE. /
*
      SAVE    OFIRST, ALU, WTBL
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL DZ2PST     !" ݥηꤹ
     O        (  ALU  , 
     I           DX   , DZ  )
*
         CALL RFFTIM            !" FFT 3Ѵؿɽ
     I        ( NX    ,
     O          WTBL  , IFAC  )
*
      ENDIF
*
*"        < 1. ZETAաꥨѴ. >
*
      CALL COPY( PSI , ZETA , (NX+2)*(NZ+2) )
*
      DO 1000 IX = 0, NX+1      !" Ȥߤ
         PSI( IX, 1 ) = PSI( IX, 1 ) - PSIBTM/(DZ)**2
         PSI( IX,NZ ) = PSI( IX,NZ ) - PSITOP/(DZ)**2
 1000 CONTINUE 
*
      CALL FFT99Y                          !" FFT Ƥ
     M         ( PSI   ,
     M           Z     ,
     C           WTBL  , 
     C           2     , NX  , NX+2  , 
     C           2     , NZ  , NZ+2  , 
     C           0                      )
*
*"        < 2. PSIΥաꥨʬ. >
*
      CALL LUSOL3   !" ̣ʬˤη׻ [ гѹ ]
     M      ( Z    ,
     I        ALU  ,
     D        1    , NX , NZ )
*
*"       < 3. եաꥨѴPSI. >
*
      CALL FFT99Y     !" FFT Ƥ
     M         ( PSI   ,
     M           Z     ,
     C           WTBL  , 
     C           2     , NX  , NX+2  , 
     C           2     , NZ  , NZ+2  , 
     C           1                      )
*
*"       < 4. Ŭ >
*
      DO 4000 IX = 0, NX+1
	PSI( IX, 0 )    = PSIBTM
	PSI( IX, NZ+1 ) = PSITOP
 4000 CONTINUE
*
      DO 4100 IZ = 0, NZ+1
         PSI(    0, IZ ) = PSI( NX, IZ ) !" Ū
         PSI( NX+1, IZ ) = PSI(  1, IZ ) !" Ū
 4100 CONTINUE
*
      RETURN
      END
************************************************************************
      SUBROUTINE DZ2PST     !" ݥηꤹ
     O	         (  ALU  , 
     I              DX   , DZ  )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [output]
      REAL       ALU  ( NX , NZ, -1:1  )   !" (3г)
*
      REAL       DX                        !" Xγʻֳ
      REAL       DZ                        !" Zγʻֳ
*
* [INTERNAL WORK]
      INTEGER IWN
      INTEGER IZ
      REAL    PI		           !" ߼Ψ
*
      SAVE
*
      PI=4.0*ATAN(1.0D0)
*
*        < 1.  >
*
*"          < 1.1 гʬ >
*
      DO 1000 IZ=1,NZ
          ALU(1,IZ,0) = - 2./(DZ**2)
          ALU(2,IZ,0) = - ( 2 * PI* (NX/2)/(NX*DX) )**2
     &                  - 2./(DZ**2)
 1000 CONTINUE

      DO 1100 IWN=4,NX,2
        DO 1100 IZ=1,NZ
          ALU(IWN,IZ,0) = - ( 2 * PI* (IWN/2-1)/(NX*DX) )**2
     &                 - 2./(DZ**2)
          ALU(IWN-1,IZ,0) =  ALU(IWN,IZ,0) 
 1100 CONTINUE
*
*"          < 1.2 гʬ >
*"		郎ȤߤޤƤ뤳Ȥ
*
      DO 1200 IWN=1,NX
        DO 1200 IZ=1,NZ
          ALU(IWN, IZ,  1) = 1./(DZ**2)
          ALU(IWN, IZ, -1) = 1./(DZ**2)
 1200 CONTINUE
*
*"        < 2. LUʬμ¹ >
*
      CALL LUMAK3        !" Σ̣ʬ [ гѹ ]
     M     ( ALU ,
     D       NX  , NZ )
*
      RETURN
      END

